#[doc = "Register `DFT_CTRL` reader"]
pub struct R(crate::R<DFT_CTRL_SPEC>);
impl core::ops::Deref for R {
    type Target = crate::R<DFT_CTRL_SPEC>;
    #[inline(always)]
    fn deref(&self) -> &Self::Target {
        &self.0
    }
}
impl core::convert::From<crate::R<DFT_CTRL_SPEC>> for R {
    fn from(reader: crate::R<DFT_CTRL_SPEC>) -> Self {
        R(reader)
    }
}
#[doc = "Register `DFT_CTRL` writer"]
pub struct W(crate::W<DFT_CTRL_SPEC>);
impl core::ops::Deref for W {
    type Target = crate::W<DFT_CTRL_SPEC>;
    #[inline(always)]
    fn deref(&self) -> &Self::Target {
        &self.0
    }
}
impl core::ops::DerefMut for W {
    #[inline(always)]
    fn deref_mut(&mut self) -> &mut Self::Target {
        &mut self.0
    }
}
impl core::convert::From<crate::W<DFT_CTRL_SPEC>> for W {
    fn from(writer: crate::W<DFT_CTRL_SPEC>) -> Self {
        W(writer)
    }
}
#[doc = "Field `DFT_MODE` reader - this bit is combined with bit 31, to form RMP\\[3:0\\], it must always be written with '3' for correct operation."]
pub struct DFT_MODE_R(crate::FieldReader<u8, u8>);
impl DFT_MODE_R {
    pub(crate) fn new(bits: u8) -> Self {
        DFT_MODE_R(crate::FieldReader::new(bits))
    }
}
impl core::ops::Deref for DFT_MODE_R {
    type Target = crate::FieldReader<u8, u8>;
    #[inline(always)]
    fn deref(&self) -> &Self::Target {
        &self.0
    }
}
#[doc = "Field `DFT_MODE` writer - this bit is combined with bit 31, to form RMP\\[3:0\\], it must always be written with '3' for correct operation."]
pub struct DFT_MODE_W<'a> {
    w: &'a mut W,
}
impl<'a> DFT_MODE_W<'a> {
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub unsafe fn bits(self, value: u8) -> &'a mut W {
        self.w.bits = (self.w.bits & !0x07) | (value as u32 & 0x07);
        self.w
    }
}
#[doc = "Field `DFT_EN` reader - this bit is combined with the 3 bits 2:0, to form RMP\\[3:0\\]"]
pub struct DFT_EN_R(crate::FieldReader<bool, bool>);
impl DFT_EN_R {
    pub(crate) fn new(bits: bool) -> Self {
        DFT_EN_R(crate::FieldReader::new(bits))
    }
}
impl core::ops::Deref for DFT_EN_R {
    type Target = crate::FieldReader<bool, bool>;
    #[inline(always)]
    fn deref(&self) -> &Self::Target {
        &self.0
    }
}
#[doc = "Field `DFT_EN` writer - this bit is combined with the 3 bits 2:0, to form RMP\\[3:0\\]"]
pub struct DFT_EN_W<'a> {
    w: &'a mut W,
}
impl<'a> DFT_EN_W<'a> {
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x01 << 31)) | ((value as u32 & 0x01) << 31);
        self.w
    }
}
impl R {
    #[doc = "Bits 0:2 - this bit is combined with bit 31, to form RMP\\[3:0\\], it must always be written with '3' for correct operation."]
    #[inline(always)]
    pub fn dft_mode(&self) -> DFT_MODE_R {
        DFT_MODE_R::new((self.bits & 0x07) as u8)
    }
    #[doc = "Bit 31 - this bit is combined with the 3 bits 2:0, to form RMP\\[3:0\\]"]
    #[inline(always)]
    pub fn dft_en(&self) -> DFT_EN_R {
        DFT_EN_R::new(((self.bits >> 31) & 0x01) != 0)
    }
}
impl W {
    #[doc = "Bits 0:2 - this bit is combined with bit 31, to form RMP\\[3:0\\], it must always be written with '3' for correct operation."]
    #[inline(always)]
    pub fn dft_mode(&mut self) -> DFT_MODE_W {
        DFT_MODE_W { w: self }
    }
    #[doc = "Bit 31 - this bit is combined with the 3 bits 2:0, to form RMP\\[3:0\\]"]
    #[inline(always)]
    pub fn dft_en(&mut self) -> DFT_EN_W {
        DFT_EN_W { w: self }
    }
    #[doc = "Writes raw bits to the register."]
    pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
        self.0.bits(bits);
        self
    }
}
#[doc = "Was 'Analog DfT controls', now used as Risk Mitigation bits (RMP)\n\nThis register you can [`read`](crate::generic::Reg::read), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [dft_ctrl](index.html) module"]
pub struct DFT_CTRL_SPEC;
impl crate::RegisterSpec for DFT_CTRL_SPEC {
    type Ux = u32;
}
#[doc = "`read()` method returns [dft_ctrl::R](R) reader structure"]
impl crate::Readable for DFT_CTRL_SPEC {
    type Reader = R;
}
#[doc = "`write(|w| ..)` method takes [dft_ctrl::W](W) writer structure"]
impl crate::Writable for DFT_CTRL_SPEC {
    type Writer = W;
}
#[doc = "`reset()` method sets DFT_CTRL to value 0"]
impl crate::Resettable for DFT_CTRL_SPEC {
    #[inline(always)]
    fn reset_value() -> Self::Ux {
        0
    }
}
